window.onload = function() {

	log = function(a){
		if(console){console.log(a);}
	}
	
	// grootte van venster
	var winW = 630, winH = 460;
	if (document.body && document.body.offsetWidth) {
	 winW = document.body.offsetWidth;
	 winH = document.body.offsetHeight;
	}
	if (document.compatMode=='CSS1Compat' &&
		document.documentElement &&
		document.documentElement.offsetWidth ) {
	 winW = document.documentElement.offsetWidth;
	 winH = document.documentElement.offsetHeight;
	}
	if (window.innerWidth && window.innerHeight) {
	 winW = window.innerWidth;
	 winH = window.innerHeight;
	}
	//grootte van de wereld
	siz = { x: Math.floor(winW/16), y: Math.floor(winH/16) };
	
	cdgrid = function(){
		this.size= {x: siz.x, y: siz.y};
		this.grid= [];
	}
	cdgrid.prototype.init = function(){
		for( var i = 0; i < this.size.x; i++){
			this.grid[i] = [];
			for(var j = 0; j < siz.y; j++) {
				this.grid[i][j] = {val: 0, set: 0}
			}
		}
	}
	cdgrid.prototype.set = function(x,y,val,set){
		this.grid[x][y].val = val;
		this.grid[x][y].set = set;
	}
	cdgrid.prototype.step = function(){
		for(var i = 1; i < siz.x-1; i++) {
			for(var j = 1; j < siz.y-1; j++) {
				if(!this.grid[i][j].set){
					// exponentieel
				//	this.grid[i][j].val=(this.grid[i+1][j].val+this.grid[i-1][j].val+this.grid[i][j+1].val+this.grid[i][j-1].val)/4;
					// lineair
					this.grid[i][j].val=Math.max(this.grid[i+1][j].val+this.grid[i-1][j].val+this.grid[i][j+1].val+this.grid[i][j-1].val)-1;
				}
			}
		}
	}
	cdgrid.prototype.move = function(x,y){
		dir = 0; //blijven staan
		max = this.grid[x][y].val;
		if ( this.grid[x][y-1].val > max ){
			dir = 1; //boven
			max = this.grid[x][y-1].val;
		}
		if ( this.grid[x+1][y].val > max ){
			dir = 2; //rechts
			max = this.grid[x+1][y].val;
		}
		if ( this.grid[x][y+1].val > max ){
			dir = 3; //onder
			max = this.grid[x][y+1].val;
		}
		if ( this.grid[x-1][y].val > max ){
			dir = 4; //links
			max = this.grid[x-1][y].val;
		}
		return dir;
	}
	
	cdplay = new cdgrid();
	cdplay.init();

	//start crafty
	Crafty.init(siz.x*16, siz.y*16);
	Crafty.canvas.init();
	
	//turn the sprite map into usable components
	Crafty.sprite(16, "sprite.png", {
		grass1: [0,0],
		grass2: [1,0],
		grass3: [2,0],
		grass4: [3,0],
		flower1: [0,1],
		flower2: [1,1],
		flower3: [2,1],
		flower4: [3,1],
		bush1: [0,2],
		bush2: [1,2],
		player: [0,3]
	});
	
	//method to randomy generate the map
	function generateWorld() {
		//generate the grass along the x-axis
		for(var i = 0; i < siz.x; i++) {
			//generate the grass along the y-axis
			for(var j = 0; j < siz.y; j++) {
				grassType = Crafty.math.randomInt(1, 4);
				Crafty.e("2D, Canvas, Mouse, grass"+grassType)
					.attr({x: i * 16, y: j * 16})
					.bind("Click", function(obj) {
						cdplay.set(this.x/16,this.y/16,100,1);
					});
				
				//1/50 chance of drawing a flower and only within the bushes
				if(i > 0 && i < siz.x-1 && j > 0 && j < siz.y-1 && Crafty.math.randomInt(0, 50) > 49) {
					Crafty.e("2D, DOM, flower, flower"+Crafty.math.randomInt(1,4))
						.attr({x: i * 16, y: j * 16})
						/*..animate("wind", 0, 1, 3)
						.animate("wind", 80, -1)
						bind("EnterFrame", function() {
							// if(!this.isPlaying())
							//	log("hoi");
							//	this.animate("wind", 80);
						})*/;
						cdplay.set(i,j,100,1);
				}else if(i > 0 && i < siz.x-1 && j > 0 && j < siz.y-1 && Crafty.math.randomInt(0, 50) > 49) {
					Crafty.e("2D, Canvas, wall, solid, bush"+Crafty.math.randomInt(1,2))
					.attr({x: i*16, y: j*16});
					cdplay.set(i,j,0,1);
				}
			}
		}
		
		//create the bushes along the x-axis which will form the boundaries
		for(var i = 0; i < siz.x; i++) {
			Crafty.e("2D, Canvas, wall_top, solid, bush"+Crafty.math.randomInt(1,2))
				.attr({x: i * 16, y: 0, z: 2});
						cdplay.set(i,0,0,1);
			Crafty.e("2D, Canvas, wall_bottom, solid, bush"+Crafty.math.randomInt(1,2))
				.attr({x: i * 16, y: (siz.y-1)*16, z: 2});
						cdplay.set(i,siz.y-1,0,1);
		}
		
		//create the bushes along the y-axis
		//we need to start one more and one less to not overlap the previous bushes
		for(var i = 1; i < siz.y-1; i++) {
			Crafty.e("2D, Canvas, wall_left, solid, bush"+Crafty.math.randomInt(1,2))
				.attr({x: 0, y: i * 16, z: 2});
						cdplay.set(0,i,0,1);
			Crafty.e("2D, Canvas, wall_right, solid, bush"+Crafty.math.randomInt(1,2))
				.attr({x: (siz.x-1)*16, y: i * 16, z: 2});
						cdplay.set(siz.x-1,i,0,1);
		}
	}
	
	//the loading screen that will display while our assets load
	Crafty.scene("loading", function() {
		//load takes an array of assets and a callback when complete
		Crafty.load(["sprite.png"], function () {
			Crafty.scene("main"); //when everything is loaded, run the main scene
		});
		
		//black background with some loading text
		Crafty.background("#000");
		Crafty.e("2D, DOM, Text").attr({w: 100, h: 20, x: 150, y: 120})
			.text("Loading")
			.css({"text-align": "center"});
	});
	
	//automatically play the loading scene
	Crafty.scene("loading");
	
	Crafty.scene("main", function() {
		generateWorld();
		
		Crafty.c('Hero', {
			init: function() {
					//setup animations
					this.requires("SpriteAnimation, Collision")
					.animate("walk_left", 6, 3, 8)
					.animate("walk_right", 9, 3, 11)
					.animate("walk_up", 3, 3, 5)
					.animate("walk_down", 0, 3, 2)
					//change direction when a direction change event is received
					.bind("NewDirection",
						function (direction) {
							if (direction.x < 0) {
								if (!this.isPlaying("walk_left"))
									this.stop().animate("walk_left", 10, -1);
							}
							if (direction.x > 0) {
								if (!this.isPlaying("walk_right"))
									this.stop().animate("walk_right", 10, -1);
							}
							if (direction.y < 0) {
								if (!this.isPlaying("walk_up"))
									this.stop().animate("walk_up", 10, -1);
							}
							if (direction.y > 0) {
								if (!this.isPlaying("walk_down"))
									this.stop().animate("walk_down", 10, -1);
							}
							if(!direction.x && !direction.y) {
								this.stop();
							}
					})
					// A rudimentary way to prevent the user from passing solid areas
					.bind('Moved', function(from) {
						if(this.hit('solid')){
							this.attr({x: from.x, y:from.y});
						}
					});
				return this;
			}
		});

		Crafty.c("RightControls", {
			init: function() {
				this.requires('Multiway');
			},

			rightControls: function(speed) {
				this.multiway(speed, {UP_ARROW: -90, DOWN_ARROW: 90, RIGHT_ARROW: 0, LEFT_ARROW: 180})
				return this;
			}

		});
		
		//create our player entity with some premade components
		player = Crafty.e("2D, Canvas, player, Hero, Animate, Collision")
			.attr({x: Math.round(siz.x/2)*16, y: Math.round(siz.y/2)*16, z: 1})
			.bind('doestap', function(){
				var richt = cdplay.move(this.x/16, this.y/16); 
				if(richt==1){ this.y -= 16; }
				if(richt==2){ this.x += 16; }
				if(richt==3){ this.y += 16; }
				if(richt==4){ this.x -= 16; }
				flhit = this.hit('flower')
					if(flhit){
						cdplay.set(flhit[0].obj.x/16, flhit[0].obj.y/16, 0, 0);
						Crafty(flhit[0].obj[0]).destroy();
					}
			})
			.requires('KeyBoard').bind('KeyDown', function (e) { 
				if ( e.key == Crafty.keys['SPACE']){
					this.trigger('doestap');
				}
			})
			.bind('EnterFrame', function(){cdplay.step();this.trigger('doestap');});
	});
};